'Keyboard matrix scanner
'HW: pic 16F88 @ 8 MHz (internal)
'Versione 5: uscita codici naturali (non interpretati)
Define CONF_WORD = 0x2f11
Define CONF_WORD_2 = 0x3ffc

Const snd_dur = 200

Symbol row_in = PORTA
Symbol row1 = RA2
Symbol row2 = RA3
Symbol row3 = RA4
Symbol row4 = RA5

Symbol key_port = PORTB
Symbol col1 = RB0
Symbol col2 = RB1
Symbol col3 = RB2
Symbol col4 = RB3

Symbol bcd = PORTB
Symbol strobe = RA1
Symbol buzzer = RA0
Symbol led = RA7

Dim key As Byte
Dim aux As Byte
Dim count1 As Byte
Dim counta As Byte
Dim countb As Byte
Dim rowbits As Byte
Dim fkey_found As Bit

OSCCON = %01110000
OPTION = 0
AllDigital
TRISA = %00111100
TRISB = %00000000

strobe = 1
led = 0
buzzer = 0

ASM:        bsf led
ASM:        bsf buzzer
ASM:        call d0
ASM:        bcf led
ASM:        bcf buzzer
ASM:        call d0

ASM:        bsf led
ASM:        bsf buzzer
ASM:        call d0
ASM:        bcf led
ASM:        bcf buzzer
ASM:        call d0

ASM:        bsf led
ASM:        bsf buzzer
ASM:        call d0
ASM:        bcf led
ASM:        bcf buzzer
ASM:        call d0

'Keypad subroutine

ASM:chk_keys: movlw 0x00  'wait until no key pressed
ASM:        movwf KEY_PORT  'set all Output pins Low
ASM:        movf row_in,W
ASM:        movwf rowbits  'xxBBBBxx
ASM:        rrf rowbits,f
ASM:        rrf rowbits,w  'xxxxBBBB
ASM:        andlw 0x0F  'mask off High Byte
ASM:        sublw 0x0F
ASM:        btfsc STATUS,Z  'test If any key pressed
ASM:        Goto Keys  'If none, Read keys
ASM:        Call Delay20
ASM:        Goto Chk_Keys  'Else try again

ASM:Keys:   Call Scan_Keys
ASM:        movlw 0x10  'check For no key pressed
ASM:        subwf key,W
ASM:        btfss STATUS,Z
ASM:        Goto Key_Found
ASM:        Call delay20
ASM:        Goto Keys

'------------------------------------------------

ASM:Key_Found:
ASM:        movf key,w
'ASM:        call read_codes
'ASM:        movwf key
ASM:        swapf key,w
ASM:        iorwf portb,f
ASM:        bsf led
ASM:        bsf buzzer
ASM:        bcf strobe

ASM:        movlw snd_dur
ASM:        call d0
ASM:        bcf buzzer
ASM:        bcf led
ASM:        bsf strobe


'ASM:        movf portb,w
'ASM:        andlw 0x0f
'ASM:        movwf portb
ASM:        goto chk_keys

'------------------------------------------------
ASM:Scan_Keys: clrf key
ASM:        movlw 0x0f
ASM:        iorwf KEY_PORT,f  'set all Output lines High
ASM:        bcf fkey_found

ASM:scan:   bcf col1
ASM:        call Scan_row
ASM:        bsf col1
ASM:        btfsc fkey_found
ASM:        goto endscan

ASM:        bcf col2
ASM:        call Scan_row
ASM:        bsf col2
ASM:        btfsc fkey_found
ASM:        goto endscan

ASM:        bcf col3
ASM:        call Scan_row
ASM:        bsf col3
ASM:        btfsc fkey_found
ASM:        goto endscan

ASM:        bcf col4
ASM:        call Scan_row
ASM:        bsf col4

ASM:endscan: Return


ASM:Scan_row:
ASM:        btfss row1
ASM:        goto pressed

ASM:        incf key,F
ASM:        btfss row2
ASM:        goto pressed

ASM:        incf key,F
ASM:        btfss row3
ASM:        goto pressed

ASM:        incf key,F
ASM:        btfss row4
ASM:        goto pressed
ASM:        incf key,F
ASM:        goto endrow
ASM:pressed: bsf fkey_found
ASM:endrow: return


ASM:delay20: movlw D  '20'   ;delay 20mS
ASM:d0:     movwf count1
'ASM:        return

ASM:d00:    call d1
ASM:d1:     movlw 0xC7 ;delay 500usec
ASM:        movwf counta
ASM:        movlw 0x01
ASM:        movwf countb
ASM:Delay_0: decfsz counta,F
ASM:        Goto $+2
ASM:        decfsz countb,F
ASM:        Goto Delay_0

ASM:        decfsz count1,F
ASM:        Goto d1
ASM:        return

End                                               

'mappatura tasti / codici
ASM:read_codes:
ASM:        addwf pcl,f
ASM:        retlw 1
ASM:        retlw 4
ASM:        retlw 7
ASM:        retlw 14
ASM:        retlw 2
ASM:        retlw 5
ASM:        retlw 8
ASM:        retlw 0
ASM:        retlw 3
ASM:        retlw 6
ASM:        retlw 9
ASM:        retlw 15
ASM:        retlw 10
ASM:        retlw 11
ASM:        retlw 12
ASM:        retlw 13